/*eslint-disable react/no-set-state */
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _d = require('d3');

var _d2 = _interopRequireDefault(_d);

var _axis = require('../utilities/axis');

var _axis2 = _interopRequireDefault(_axis);

var _axisLabel = require('../utilities/axisLabel');

var _axisLabel2 = _interopRequireDefault(_axisLabel);

var _grid = require('../utilities/grid');

var _grid2 = _interopRequireDefault(_grid);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BarGraph = function (_React$Component) {
  _inherits(BarGraph, _React$Component);

  function BarGraph(props) {
    _classCallCheck(this, BarGraph);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(BarGraph).call(this, props));

    _this.componentWillMount = _this.componentWillMount.bind(_this);
    _this.state = {
      width: _this.props.width,
      data: []
    };
    return _this;
  }

  _createClass(BarGraph, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _self = this;
      window.addEventListener('resize', function () {
        _self.updateSize();
      }, true);
      this.setState({ width: this.props.width });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.reloadBarData();
      this.repaintComponent();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var _self = this;
      window.removeEventListener('resize', function () {
        _self.updateSize();
      });
    }
  }, {
    key: 'repaintComponent',
    value: function repaintComponent() {
      var _self = this;
      var forceResize = function forceResize() {
        _self.updateSize();
      };
      function onRepaint(callback) {
        setTimeout(function () {
          window.requestAnimationFrame(callback);
        }, 0);
      }
      onRepaint(forceResize);
    }
  }, {
    key: 'createChart',
    value: function createChart(_self) {

      this.color = _d2.default.scale.category10();

      var xLabelHeightOffset = 0;
      var yLabelWidthOffset = 0;

      if (this.props.xAxisLabel) {
        xLabelHeightOffset = 30;
      }

      if (this.props.yAxisLabel) {
        yLabelWidthOffset = 20;
      }

      // Width of graph
      this.w = this.state.width - (this.props.margin.left + this.props.margin.right + yLabelWidthOffset);

      // Height of graph
      this.h = this.props.height - (this.props.margin.top + this.props.margin.bottom + xLabelHeightOffset);

      this.stacked = _d2.default.layout.stack()(_self.props.keys.map(function (key) {
        return _self.state.data.map(function (d) {
          return { x: d[_self.props.xData], y: d[key] };
        });
      }));

      // X axis scale
      this.xScale = _d2.default.scale.ordinal().rangeRoundBands([0, this.w], .3).domain(this.stacked[0].map(function (d) {
        return d.x;
      }));

      // Y axis scale
      this.yScale = _d2.default.scale.linear().rangeRound([this.h, 0]).domain([0, _d2.default.max(this.stacked[this.stacked.length - 1], function (d) {
        return d.y0 + d.y;
      })]).nice();

      this.yAxis = _d2.default.svg.axis().scale(this.yScale).orient('left').ticks(5);

      this.xAxis = _d2.default.svg.axis().scale(this.xScale).orient('bottom').ticks(this.state.data.length);

      this.yGrid = _d2.default.svg.axis().scale(this.yScale).orient('left').ticks(5).tickSize(-this.w, 0, 0).tickFormat("");

      this.transform = 'translate(' + (this.props.margin.left + yLabelWidthOffset) + ',' + this.props.margin.top + ')';
    }
  }, {
    key: 'reloadBarData',
    value: function reloadBarData() {

      var data = this.props.data;

      this.setState({ data: data });
    }
  }, {
    key: 'updateSize',
    value: function updateSize() {
      var node = _reactDom2.default.findDOMNode(this);
      var parentWidth = node.offsetWidth;
      if (parentWidth < this.props.width) {
        this.setState({ width: parentWidth });
      } else {
        this.setState({ width: this.props.width });
      }
    }
  }, {
    key: 'render',
    value: function render() {

      this.createChart(this);

      var _self = this;

      var bars = _self.stacked.map(function (data, i) {
        var rects = data.map(function (d, j) {
          return _react2.default.createElement('rect', {
            x: _self.xScale(d.x),
            y: _self.yScale(d.y + d.y0),
            fill: _self.color(i),
            height: _self.yScale(d.y0) - _self.yScale(d.y + d.y0),
            width: _self.xScale.rangeBand(),
            key: j });
        });

        return _react2.default.createElement(
          'g',
          { key: i },
          rects
        );
      });

      var title = void 0;

      if (this.props.title) {
        title = _react2.default.createElement(
          'h3',
          null,
          this.props.title
        );
      }

      var axisLabels = [];

      if (this.props.xAxisLabel) {
        axisLabels.push(_react2.default.createElement(_axisLabel2.default, { key: 0, h: this.h, w: this.w, axisLabel: this.props.yAxisLabel, axisType: 'y' }));
      }

      if (this.props.yAxisLabel) {
        axisLabels.push(_react2.default.createElement(_axisLabel2.default, { key: 1, h: this.h, w: this.w, axisLabel: this.props.xAxisLabel, axisType: 'x' }));
      }

      var customClassName = "";

      if (this.props.chartClassName) {
        customClassName = " " + this.props.chartClassName;
      }

      return _react2.default.createElement(
        'div',
        null,
        title,
        _react2.default.createElement(
          'svg',
          { className: "rd3r-chart rd3r-bar-graph" + customClassName, id: this.props.chartId, width: this.state.width, height: this.props.height },
          _react2.default.createElement(
            'g',
            { transform: this.transform },
            _react2.default.createElement(_grid2.default, { h: this.h, grid: this.yGrid, gridType: 'y' }),
            _react2.default.createElement(_axis2.default, { h: this.h, axis: this.yAxis, axisType: 'y' }),
            _react2.default.createElement(_axis2.default, { h: this.h, axis: this.xAxis, axisType: 'x' }),
            axisLabels,
            bars
          )
        )
      );
    }
  }]);

  return BarGraph;
}(_react2.default.Component);

BarGraph.propTypes = {
  title: _react2.default.PropTypes.string,
  width: _react2.default.PropTypes.number,
  height: _react2.default.PropTypes.number,
  chartId: _react2.default.PropTypes.string,
  chartClassName: _react2.default.PropTypes.string,
  data: _react2.default.PropTypes.array.isRequired,
  xData: _react2.default.PropTypes.string.isRequired,
  xAxisLabel: _react2.default.PropTypes.string,
  yAxisLabel: _react2.default.PropTypes.string,
  keys: _react2.default.PropTypes.array.isRequired,
  margin: _react2.default.PropTypes.object
};

BarGraph.defaultProps = {
  width: 1920,
  height: 400,
  margin: {
    top: 10,
    right: 40,
    bottom: 20,
    left: 40
  }
};

exports.default = BarGraph;