/*eslint-disable react/no-set-state */
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _d = require('d3');

var _d2 = _interopRequireDefault(_d);

var _axis = require('../utilities/axis');

var _axis2 = _interopRequireDefault(_axis);

var _axisLabel = require('../utilities/axisLabel');

var _axisLabel2 = _interopRequireDefault(_axisLabel);

var _grid = require('../utilities/grid');

var _grid2 = _interopRequireDefault(_grid);

var _dataPoints = require('../utilities/dataPoints');

var _dataPoints2 = _interopRequireDefault(_dataPoints);

var _tooltip = require('../utilities/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LineGraph = function (_React$Component) {
  _inherits(LineGraph, _React$Component);

  function LineGraph(props) {
    _classCallCheck(this, LineGraph);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(LineGraph).call(this, props));

    _this.showToolTip = _this.showToolTip.bind(_this);
    _this.hideToolTip = _this.hideToolTip.bind(_this);
    _this.componentWillMount = _this.componentWillMount.bind(_this);
    _this.state = {
      tooltip: {
        display: false,
        data: {
          key: '',
          value: ''
        },
        pos: {
          x: 0,
          y: 0
        }
      },
      width: _this.props.width,
      data: []
    };
    return _this;
  }

  _createClass(LineGraph, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _self = this;
      window.addEventListener('resize', function () {
        _self.updateSize();
      }, true);
      this.setState({ width: this.props.width });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.reloadBarData();
      this.repaintComponent();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var _self = this;
      window.removeEventListener('resize', function () {
        _self.updateSize();
      });
    }
  }, {
    key: 'repaintComponent',
    value: function repaintComponent() {
      var _self = this;
      var forceResize = function forceResize() {
        _self.updateSize();
      };
      function onRepaint(callback) {
        setTimeout(function () {
          window.requestAnimationFrame(callback);
        }, 0);
      }
      onRepaint(forceResize);
    }
  }, {
    key: 'createChart',
    value: function createChart(_self) {

      this.color = _d2.default.scale.category10();

      var xLabelHeightOffset = 0;
      var yLabelWidthOffset = 0;

      if (this.props.xAxisLabel) {
        xLabelHeightOffset = 30;
      }

      if (this.props.yAxisLabel) {
        yLabelWidthOffset = 20;
      }

      // Width of graph
      this.w = this.state.width - (this.props.margin.left + this.props.margin.right + yLabelWidthOffset);

      // Height of graph
      this.h = this.props.height - (this.props.margin.top + this.props.margin.bottom + xLabelHeightOffset);

      // X axis scale
      if (this.props.dataType !== 'date') {
        this.xScale = _d2.default.scale.linear().domain([_d2.default.min(this.state.data, function (d) {
          return d[_self.props.xData];
        }), _d2.default.max(this.state.data, function (d) {
          return d[_self.props.xData];
        })]).range([0, this.w]);

        if (this.props.dataPercent == 'x') {
          this.xAxis = _d2.default.svg.axis().scale(this.xScale).orient('bottom').tickFormat(function (x) {
            return x + '%';
          });
        } else {
          this.xAxis = _d2.default.svg.axis().scale(this.xScale).orient('bottom').ticks(Math.floor(this.w / 100));
        }
      } else {
        this.xScale = _d2.default.time.scale().domain(
        // Find min and max axis value
        _d2.default.extent(this.state.data, function (d) {
          return d[_self.props.xData];
        }))
        // Set range from 0 to width of container
        .rangeRound([0, this.w]);

        this.xAxis = _d2.default.svg.axis().scale(this.xScale).orient('bottom').ticks(Math.floor(this.w / 100)).tickFormat(_d2.default.time.format(this.props.xFormat));
      }

      // Y axis scale
      this.yScale = _d2.default.scale.linear().domain([
      // Find min axis value and subtract buffer
      _d2.default.min(this.state.data, function (d) {
        return d[_self.props.yData] - _self.props.yMaxBuffer;
      }),
      // Find max axis value and add buffer
      _d2.default.max(this.state.data, function (d) {
        return d[_self.props.yData] + _self.props.yMaxBuffer;
      })])
      // Set range from height of container to 0
      .range([this.h, 0]);

      // Create line
      this.line = _d2.default.svg.line().x(function (d) {
        return this.xScale(d[_self.props.xData]);
      }).y(function (d) {
        return this.yScale(d[_self.props.yData]);
      }).interpolate(this.props.lineType);

      this.dataNest = _d2.default.nest().key(function (d) {
        return d.type;
      }).entries(this.state.data);

      if (this.props.dataPercent == 'y') {
        this.yAxis = _d2.default.svg.axis().scale(this.yScale).orient('left').ticks(5).tickFormat(function (x) {
          return x + '%';
        });
      } else {
        this.yAxis = _d2.default.svg.axis().scale(this.yScale).orient('left').ticks(5);
      }

      this.yGrid = _d2.default.svg.axis().scale(this.yScale).orient('left').ticks(5).tickSize(-this.w, 0, 0).tickFormat("");

      this.transform = 'translate(' + (this.props.margin.left + yLabelWidthOffset) + ',' + this.props.margin.top + ')';
    }
  }, {
    key: 'reloadBarData',
    value: function reloadBarData() {

      var data = this.props.data;

      // Format date for d3 to use
      var parseDate = _d2.default.time.format(this.props.dateFormat).parse;

      for (var i = 0; i < data.length; ++i) {
        var d = data[i];
        if (this.props.dataType == 'date') {
          if (typeof d[this.props.xData] === "string") {
            d[this.props.xData] = parseDate(d[this.props.xData]);
          }
          data[i] = d;
        }
      }

      this.setState({ data: data });
    }
  }, {
    key: 'updateSize',
    value: function updateSize() {
      var node = _reactDom2.default.findDOMNode(this);
      var parentWidth = node.offsetWidth;
      if (parentWidth < this.props.width) {
        this.setState({ width: parentWidth });
      } else {
        this.setState({ width: this.props.width });
      }
    }
  }, {
    key: 'showToolTip',
    value: function showToolTip(e) {
      e.target.setAttribute('fill', '#6f8679');
      this.setState({
        tooltip: {
          display: true,
          data: {
            key: e.target.getAttribute('data-key'),
            value: e.target.getAttribute('data-value')
          },
          pos: {
            x: e.target.getAttribute('cx'),
            y: e.target.getAttribute('cy')
          }
        }
      });
    }
  }, {
    key: 'hideToolTip',
    value: function hideToolTip(e) {
      e.target.setAttribute('fill', '#b1bfb7');
      this.setState({
        tooltip: {
          display: false,
          data: {
            key: '',
            value: ''
          },
          pos: {
            x: 0,
            y: 0
          }
        }
      });
    }
  }, {
    key: 'render',
    value: function render() {

      this.createChart(this);

      var _self = this;
      var lines = void 0;

      lines = this.dataNest.map(function (d, i) {
        return _react2.default.createElement(
          'g',
          { key: i },
          _react2.default.createElement('path', {
            d: _self.line(d.values),
            fill: _self.props.fillColor,
            stroke: _self.color(i),
            opacity: '.9',
            strokeWidth: 3,
            strokeLinecap: 'round' }),
          _react2.default.createElement(_dataPoints2.default, {
            data: d.values,
            x: _self.xScale,
            y: _self.yScale,
            stroke: '#ffffff',
            showToolTip: _self.showToolTip,
            hideToolTip: _self.hideToolTip,
            removeFirstAndLast: true,
            xData: _self.props.xData,
            yData: _self.props.yData }),
          _react2.default.createElement(_tooltip2.default, {
            tooltip: _self.state.tooltip,
            xValue: _self.props.xToolTipLabel,
            yValue: _self.props.yToolTipLabel })
        );
      });

      var title = void 0;

      if (this.props.title) {
        title = _react2.default.createElement(
          'h3',
          null,
          this.props.title
        );
      }

      var axisLabels = [];

      if (this.props.xAxisLabel) {
        axisLabels.push(_react2.default.createElement(_axisLabel2.default, { key: 0, h: this.h, w: this.w, axisLabel: this.props.yAxisLabel, axisType: 'y' }));
      }

      if (this.props.yAxisLabel) {
        axisLabels.push(_react2.default.createElement(_axisLabel2.default, { key: 1, h: this.h, w: this.w, axisLabel: this.props.xAxisLabel, axisType: 'x' }));
      }

      var customClassName = "";

      if (this.props.chartClassName) {
        customClassName = " " + this.props.chartClassName;
      }

      return _react2.default.createElement(
        'div',
        null,
        title,
        _react2.default.createElement(
          'svg',
          { className: "rd3r-chart rd3r-line-graph" + customClassName, id: this.props.chartId, width: this.state.width, height: this.props.height },
          _react2.default.createElement(
            'g',
            { transform: this.transform },
            _react2.default.createElement(_grid2.default, { h: this.h, grid: this.yGrid, gridType: 'y' }),
            _react2.default.createElement(_axis2.default, { h: this.h, axis: this.yAxis, axisType: 'y' }),
            _react2.default.createElement(_axis2.default, { h: this.h, axis: this.xAxis, axisType: 'x' }),
            axisLabels,
            lines
          )
        )
      );
    }
  }]);

  return LineGraph;
}(_react2.default.Component);

LineGraph.propTypes = {
  title: _react2.default.PropTypes.string,
  width: _react2.default.PropTypes.number,
  height: _react2.default.PropTypes.number,
  chartId: _react2.default.PropTypes.string,
  chartClassName: _react2.default.PropTypes.string,
  dateFormat: _react2.default.PropTypes.string,
  dataType: _react2.default.PropTypes.string,
  dataPercent: _react2.default.PropTypes.string,
  xFormat: _react2.default.PropTypes.string,
  data: _react2.default.PropTypes.array.isRequired,
  xData: _react2.default.PropTypes.string.isRequired,
  yData: _react2.default.PropTypes.string.isRequired,
  xAxisLabel: _react2.default.PropTypes.string,
  yAxisLabel: _react2.default.PropTypes.string,
  xToolTipLabel: _react2.default.PropTypes.string,
  yToolTipLabel: _react2.default.PropTypes.string,
  lineType: _react2.default.PropTypes.string,
  fillColor: _react2.default.PropTypes.string,
  margin: _react2.default.PropTypes.object,
  yMaxBuffer: _react2.default.PropTypes.number
};

LineGraph.defaultProps = {
  width: 1920,
  height: 400,
  dateFormat: '%m-%d-%Y',
  dataType: 'date',
  xFormat: '%a %e',
  xToolTipLabel: 'x',
  yToolTipLabel: 'y',
  lineType: 'linear',
  fillColor: 'transparent',
  margin: {
    top: 10,
    right: 40,
    bottom: 20,
    left: 40
  },
  yMaxBuffer: 100
};

exports.default = LineGraph;